<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: Bullet Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classBullet-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Bullet Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><a class="el" href="classBullet.html" title="Bullet projectile with ability to bounce off borders.">Bullet</a> projectile with ability to bounce off borders.  
 <a href="classBullet.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="Projectile_8h_source.html">Projectile.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Bullet:</div>
<div class="dyncontent">
<div class="center"><img src="classBullet__inherit__graph.png" border="0" usemap="#Bullet_inherit__map" alt="Inheritance graph"/></div>
<map name="Bullet_inherit__map" id="Bullet_inherit__map">
<area shape="rect" title="Bullet projectile with ability to bounce off borders." alt="" coords="27,229,87,256"/>
<area shape="rect" href="classProjectile.html" title="class representing projectiles with their own speed, damage and sprites" alt="" coords="15,155,98,181"/>
<area shape="rect" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties." alt="" coords="5,80,108,107"/>
<area shape="rect" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce..." alt="" coords="25,5,89,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for Bullet:</div>
<div class="dyncontent">
<div class="center"><img src="classBullet__coll__graph.png" border="0" usemap="#Bullet_coll__map" alt="Collaboration graph"/></div>
<map name="Bullet_coll__map" id="Bullet_coll__map">
<area shape="rect" title="Bullet projectile with ability to bounce off borders." alt="" coords="27,229,87,256"/>
<area shape="rect" href="classProjectile.html" title="class representing projectiles with their own speed, damage and sprites" alt="" coords="15,155,98,181"/>
<area shape="rect" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties." alt="" coords="5,80,108,107"/>
<area shape="rect" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce..." alt="" coords="25,5,89,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a0fafff39183a018fed0233049d3aa0ca"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classBullet.html#a0fafff39183a018fed0233049d3aa0ca">Bullet</a> (int x, int y, int vectX, int vectY)</td></tr>
<tr class="memdesc:a0fafff39183a018fed0233049d3aa0ca"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a new <a class="el" href="classBullet.html" title="Bullet projectile with ability to bounce off borders.">Bullet</a> object with given coordinates and movement vector.  <a href="classBullet.html#a0fafff39183a018fed0233049d3aa0ca">More...</a><br /></td></tr>
<tr class="separator:a0fafff39183a018fed0233049d3aa0ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaa6813fa215431eea252ca9adfd99a48"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classBullet.html#aaa6813fa215431eea252ca9adfd99a48">OnBorderCollision</a> () override</td></tr>
<tr class="memdesc:aaa6813fa215431eea252ca9adfd99a48"><td class="mdescLeft">&#160;</td><td class="mdescRight">Makes bullets bounce off borders.  <a href="classBullet.html#aaa6813fa215431eea252ca9adfd99a48">More...</a><br /></td></tr>
<tr class="separator:aaa6813fa215431eea252ca9adfd99a48"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classProjectile"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classProjectile')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classProjectile.html">Projectile</a></td></tr>
<tr class="memitem:a29f8169d5b3e6df60de4b5c7d015ae02 inherit pub_methods_classProjectile"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classProjectile.html#a29f8169d5b3e6df60de4b5c7d015ae02">Projectile</a> (int x, int y, int vectX, int vectY)</td></tr>
<tr class="memdesc:a29f8169d5b3e6df60de4b5c7d015ae02 inherit pub_methods_classProjectile"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a new <a class="el" href="classProjectile.html" title="class representing projectiles with their own speed, damage and sprites">Projectile</a> object with given coordinates and movement vector.  <a href="classProjectile.html#a29f8169d5b3e6df60de4b5c7d015ae02">More...</a><br /></td></tr>
<tr class="separator:a29f8169d5b3e6df60de4b5c7d015ae02 inherit pub_methods_classProjectile"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a42c3fc33d84481ac3e7b46eaa3990719 inherit pub_methods_classProjectile"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classProjectile.html#a42c3fc33d84481ac3e7b46eaa3990719">Update</a> ()</td></tr>
<tr class="memdesc:a42c3fc33d84481ac3e7b46eaa3990719 inherit pub_methods_classProjectile"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pure virtual Update function that is used in <a class="el" href="classGameScene.html" title="Mayer singlton class of GameScene, keeps track of all GameObjects. Updates GameObjects,...">GameScene</a>'s game loop.  <a href="classProjectile.html#a42c3fc33d84481ac3e7b46eaa3990719">More...</a><br /></td></tr>
<tr class="separator:a42c3fc33d84481ac3e7b46eaa3990719 inherit pub_methods_classProjectile"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f2eea984180f9b5d9d6a4da97bbff33 inherit pub_methods_classProjectile"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classProjectile.html#a9f2eea984180f9b5d9d6a4da97bbff33">Visit</a> (<a class="el" href="classCollisionVisitor.html">CollisionVisitor</a> *visitor) override</td></tr>
<tr class="memdesc:a9f2eea984180f9b5d9d6a4da97bbff33 inherit pub_methods_classProjectile"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pure virtual function for accepting visitor.  <a href="classProjectile.html#a9f2eea984180f9b5d9d6a4da97bbff33">More...</a><br /></td></tr>
<tr class="separator:a9f2eea984180f9b5d9d6a4da97bbff33 inherit pub_methods_classProjectile"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae28e683bcb0193b6ec33defda53caed7 inherit pub_methods_classProjectile"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classProjectile.html#ae28e683bcb0193b6ec33defda53caed7">CollideWith</a> (<a class="el" href="classGameObject.html">GameObject</a> *collisionObject) override</td></tr>
<tr class="memdesc:ae28e683bcb0193b6ec33defda53caed7 inherit pub_methods_classProjectile"><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates Visitor object and passes collisionObject parameter.  <a href="classProjectile.html#ae28e683bcb0193b6ec33defda53caed7">More...</a><br /></td></tr>
<tr class="separator:ae28e683bcb0193b6ec33defda53caed7 inherit pub_methods_classProjectile"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8f51d1cc762b462b94c280fff8ea7a7f inherit pub_methods_classProjectile"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classProjectile.html#a8f51d1cc762b462b94c280fff8ea7a7f">GetDmg</a> () const</td></tr>
<tr class="separator:a8f51d1cc762b462b94c280fff8ea7a7f inherit pub_methods_classProjectile"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classGameObject"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classGameObject')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classGameObject.html">GameObject</a></td></tr>
<tr class="memitem:a0348e3ee2e83d56eafca7a3547f432c4 inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a0348e3ee2e83d56eafca7a3547f432c4">GameObject</a> ()</td></tr>
<tr class="memdesc:a0348e3ee2e83d56eafca7a3547f432c4 inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a new <a class="el" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties.">GameObject</a> and initializes internal variables.  <a href="classGameObject.html#a0348e3ee2e83d56eafca7a3547f432c4">More...</a><br /></td></tr>
<tr class="separator:a0348e3ee2e83d56eafca7a3547f432c4 inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a224d4f6d9dd75c8a6f9d022eaf586fd9 inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a224d4f6d9dd75c8a6f9d022eaf586fd9">~GameObject</a> ()</td></tr>
<tr class="memdesc:a224d4f6d9dd75c8a6f9d022eaf586fd9 inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual destructor that ensures correct memory handling in derived classes.  <a href="classGameObject.html#a224d4f6d9dd75c8a6f9d022eaf586fd9">More...</a><br /></td></tr>
<tr class="separator:a224d4f6d9dd75c8a6f9d022eaf586fd9 inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd237fc51b336232cd5d97ca0a3266ec inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#afd237fc51b336232cd5d97ca0a3266ec">SetBoundBox</a> (int Width, int Height)</td></tr>
<tr class="memdesc:afd237fc51b336232cd5d97ca0a3266ec inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the bound box for collision handling.  <a href="classGameObject.html#afd237fc51b336232cd5d97ca0a3266ec">More...</a><br /></td></tr>
<tr class="separator:afd237fc51b336232cd5d97ca0a3266ec inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe84ab4b266362535372065ed0aacdfb inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#afe84ab4b266362535372065ed0aacdfb">GetBoundWidth</a> ()</td></tr>
<tr class="separator:afe84ab4b266362535372065ed0aacdfb inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbf0266f9230693a470181d4ee9ef9e8 inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#acbf0266f9230693a470181d4ee9ef9e8">GetBoundHeight</a> ()</td></tr>
<tr class="separator:acbf0266f9230693a470181d4ee9ef9e8 inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a14a2649fb1de4e3e705fb54df2df8f9b inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a14a2649fb1de4e3e705fb54df2df8f9b">SetMovementVector</a> (int vx, int vy)</td></tr>
<tr class="memdesc:a14a2649fb1de4e3e705fb54df2df8f9b inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a movement vector.  <a href="classGameObject.html#a14a2649fb1de4e3e705fb54df2df8f9b">More...</a><br /></td></tr>
<tr class="separator:a14a2649fb1de4e3e705fb54df2df8f9b inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a24428667f904a6445594d884476c67ac inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a24428667f904a6445594d884476c67ac">GetMoveDirHorizontal</a> ()</td></tr>
<tr class="separator:a24428667f904a6445594d884476c67ac inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a68ce660066e5dbc9c1ac9be4fabc558f inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a68ce660066e5dbc9c1ac9be4fabc558f">ObjectMove</a> ()</td></tr>
<tr class="memdesc:a68ce660066e5dbc9c1ac9be4fabc558f inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Moves <a class="el" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties.">GameObject</a> in direction of a movement vector.  <a href="classGameObject.html#a68ce660066e5dbc9c1ac9be4fabc558f">More...</a><br /></td></tr>
<tr class="separator:a68ce660066e5dbc9c1ac9be4fabc558f inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8133e4ab74ef92b50c14c18382b2397e inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a8133e4ab74ef92b50c14c18382b2397e">Intersects</a> (<a class="el" href="classGameObject.html">GameObject</a> *obj)</td></tr>
<tr class="memdesc:a8133e4ab74ef92b50c14c18382b2397e inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Whenever <a class="el" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties.">GameObject</a> intersects with obj it resolves collision with use of double dispatch visitor pattern represented by class <a class="el" href="classCollisionVisitor.html" title="Abstract class of double dispatch visitor design patter.">CollisionVisitor</a>.  <a href="classGameObject.html#a8133e4ab74ef92b50c14c18382b2397e">More...</a><br /></td></tr>
<tr class="separator:a8133e4ab74ef92b50c14c18382b2397e inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classObject"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classObject')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classObject.html">Object</a></td></tr>
<tr class="memitem:a40860402e64d8008fb42329df7097cdb inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a40860402e64d8008fb42329df7097cdb">Object</a> ()</td></tr>
<tr class="memdesc:a40860402e64d8008fb42329df7097cdb inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a new <a class="el" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...">Object</a> and initializes internal variables.  <a href="classObject.html#a40860402e64d8008fb42329df7097cdb">More...</a><br /></td></tr>
<tr class="separator:a40860402e64d8008fb42329df7097cdb inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad644b8a35c64ade4e15b3e33a2a5d77f inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#ad644b8a35c64ade4e15b3e33a2a5d77f">GetX</a> () const</td></tr>
<tr class="separator:ad644b8a35c64ade4e15b3e33a2a5d77f inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65d30f9f3b22ed328cb24482ed4ba896 inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a65d30f9f3b22ed328cb24482ed4ba896">GetY</a> () const</td></tr>
<tr class="separator:a65d30f9f3b22ed328cb24482ed4ba896 inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab04c46e902c454a25751f900948d6d5e inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#ab04c46e902c454a25751f900948d6d5e">ForcedRender</a> ()</td></tr>
<tr class="memdesc:ab04c46e902c454a25751f900948d6d5e inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Forces <a class="el" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...">Object</a> to render even if position didnt changed.  <a href="classObject.html#ab04c46e902c454a25751f900948d6d5e">More...</a><br /></td></tr>
<tr class="separator:ab04c46e902c454a25751f900948d6d5e inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2199afbf2f52ff746c4c871e434ff20f inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a2199afbf2f52ff746c4c871e434ff20f">Render</a> ()</td></tr>
<tr class="memdesc:a2199afbf2f52ff746c4c871e434ff20f inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Displays <a class="el" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...">Object</a> to ncurses stdscr.  <a href="classObject.html#a2199afbf2f52ff746c4c871e434ff20f">More...</a><br /></td></tr>
<tr class="separator:a2199afbf2f52ff746c4c871e434ff20f inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5b25442efcce1e5768e3790b36accd1a inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a5b25442efcce1e5768e3790b36accd1a">Clear</a> ()</td></tr>
<tr class="memdesc:a5b25442efcce1e5768e3790b36accd1a inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clears sprite that is being displayed to stdscr.  <a href="classObject.html#a5b25442efcce1e5768e3790b36accd1a">More...</a><br /></td></tr>
<tr class="separator:a5b25442efcce1e5768e3790b36accd1a inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6cac457fe1568b09a7f510654245972e inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a6cac457fe1568b09a7f510654245972e">SetSprite</a> (const std::string &amp;spr)</td></tr>
<tr class="memdesc:a6cac457fe1568b09a7f510654245972e inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets sprite for later rendering of <a class="el" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...">Object</a>.  <a href="classObject.html#a6cac457fe1568b09a7f510654245972e">More...</a><br /></td></tr>
<tr class="separator:a6cac457fe1568b09a7f510654245972e inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a209e2a1b3e3a30a11d1d8595a0147ffb inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a209e2a1b3e3a30a11d1d8595a0147ffb">SetXY</a> (int x, int y)</td></tr>
<tr class="memdesc:a209e2a1b3e3a30a11d1d8595a0147ffb inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets position of <a class="el" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...">Object</a>.  <a href="classObject.html#a209e2a1b3e3a30a11d1d8595a0147ffb">More...</a><br /></td></tr>
<tr class="separator:a209e2a1b3e3a30a11d1d8595a0147ffb inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adc113651aab71178e254d7d7f3b1e53b inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#adc113651aab71178e254d7d7f3b1e53b">Destroy</a> ()</td></tr>
<tr class="memdesc:adc113651aab71178e254d7d7f3b1e53b inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Marks <a class="el" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...">Object</a> for destruction and garbage collection by <a class="el" href="classGameScene.html" title="Mayer singlton class of GameScene, keeps track of all GameObjects. Updates GameObjects,...">GameScene</a>.  <a href="classObject.html#adc113651aab71178e254d7d7f3b1e53b">More...</a><br /></td></tr>
<tr class="separator:adc113651aab71178e254d7d7f3b1e53b inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae0e2dd4a28a6327bad26b43e8101e1d9 inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#ae0e2dd4a28a6327bad26b43e8101e1d9">isMarked</a> () const</td></tr>
<tr class="separator:ae0e2dd4a28a6327bad26b43e8101e1d9 inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_attribs_classProjectile"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classProjectile')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classProjectile.html">Projectile</a></td></tr>
<tr class="memitem:a3a9b60c10bc1f9e423a59c552fdfdc03 inherit pro_attribs_classProjectile"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classProjectile.html#a3a9b60c10bc1f9e423a59c552fdfdc03">m_Damage</a></td></tr>
<tr class="separator:a3a9b60c10bc1f9e423a59c552fdfdc03 inherit pro_attribs_classProjectile"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classGameObject"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classGameObject')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classGameObject.html">GameObject</a></td></tr>
<tr class="memitem:a2831bbdeef51b7dec1c886a3792a5021 inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a2831bbdeef51b7dec1c886a3792a5021">m_BoundBoxWidth</a></td></tr>
<tr class="separator:a2831bbdeef51b7dec1c886a3792a5021 inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a478d95fa66433fb8b63e1de62df32a05 inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a478d95fa66433fb8b63e1de62df32a05">m_BoundBoxHeight</a></td></tr>
<tr class="separator:a478d95fa66433fb8b63e1de62df32a05 inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a18cf227e1f9b1246ad72e555060f5602 inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a18cf227e1f9b1246ad72e555060f5602">m_MovementSpeed</a></td></tr>
<tr class="separator:a18cf227e1f9b1246ad72e555060f5602 inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a06399d2e83dbed0bbcdd23a45708e743 inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">std::chrono::time_point&lt; std::chrono::system_clock &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a06399d2e83dbed0bbcdd23a45708e743">m_LastMovementAt</a></td></tr>
<tr class="separator:a06399d2e83dbed0bbcdd23a45708e743 inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4cfd998f5afb701fdd721c5e5a00897b inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a4cfd998f5afb701fdd721c5e5a00897b">m_VectX</a></td></tr>
<tr class="separator:a4cfd998f5afb701fdd721c5e5a00897b inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aebfa0ceffe82ed29b0fd2ef37050e992 inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#aebfa0ceffe82ed29b0fd2ef37050e992">m_VectY</a></td></tr>
<tr class="separator:aebfa0ceffe82ed29b0fd2ef37050e992 inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc176e5a277e67b70ba1d2292ade28c7 inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#abc176e5a277e67b70ba1d2292ade28c7">m_DiagonalCounter</a></td></tr>
<tr class="separator:abc176e5a277e67b70ba1d2292ade28c7 inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classObject"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classObject')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classObject.html">Object</a></td></tr>
<tr class="memitem:a20bdbcf7662f94b783461df61f1dead2 inherit pro_attribs_classObject"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a20bdbcf7662f94b783461df61f1dead2">m_MarkForDestruction</a></td></tr>
<tr class="separator:a20bdbcf7662f94b783461df61f1dead2 inherit pro_attribs_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa080149410482bbf134f663f0eec478a inherit pro_attribs_classObject"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#aa080149410482bbf134f663f0eec478a">m_PositionChanged</a></td></tr>
<tr class="separator:aa080149410482bbf134f663f0eec478a inherit pro_attribs_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a995c8304abf2e3fd8fb29b59ab1048cc inherit pro_attribs_classObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a995c8304abf2e3fd8fb29b59ab1048cc">m_X</a></td></tr>
<tr class="separator:a995c8304abf2e3fd8fb29b59ab1048cc inherit pro_attribs_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1e33bf8f94303c821e0036975f1f9e44 inherit pro_attribs_classObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a1e33bf8f94303c821e0036975f1f9e44">m_Y</a></td></tr>
<tr class="separator:a1e33bf8f94303c821e0036975f1f9e44 inherit pro_attribs_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab3f832ee25ca13bad87645c44c7019e3 inherit pro_attribs_classObject"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#ab3f832ee25ca13bad87645c44c7019e3">m_Sprite</a></td></tr>
<tr class="separator:ab3f832ee25ca13bad87645c44c7019e3 inherit pro_attribs_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p><a class="el" href="classBullet.html" title="Bullet projectile with ability to bounce off borders.">Bullet</a> projectile with ability to bounce off borders. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a0fafff39183a018fed0233049d3aa0ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0fafff39183a018fed0233049d3aa0ca">&#9670;&nbsp;</a></span>Bullet()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Bullet::Bullet </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>vectX</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>vectY</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct a new <a class="el" href="classBullet.html" title="Bullet projectile with ability to bounce off borders.">Bullet</a> object with given coordinates and movement vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td>int X coordinate </td></tr>
    <tr><td class="paramname">y</td><td>int Y coordinate </td></tr>
    <tr><td class="paramname">vectX</td><td>int movement vector X direction </td></tr>
    <tr><td class="paramname">vectY</td><td>int movement vector Y direction </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aaa6813fa215431eea252ca9adfd99a48"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaa6813fa215431eea252ca9adfd99a48">&#9670;&nbsp;</a></span>OnBorderCollision()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Bullet::OnBorderCollision </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Makes bullets bounce off borders. </p>

<p>Reimplemented from <a class="el" href="classGameObject.html#a209b156ef8eec011eba664f3987d4ff7">GameObject</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="Projectile_8h_source.html">Projectile.h</a></li>
<li>src/<a class="el" href="Projectile_8cpp.html">Projectile.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
